﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace MangoTest.DAL
{
    public class User
    {
        public int UserId { get; set; }
        public string Username { get; set; }
        public string Password { get; set; }
        public string DisplayName { get; set; }
        public string ImageUrl { get; set; }

        public User(int userId, string username, string password, string displayName)
        {
            UserId = userId;
            Username = username;
            Password = password;
            DisplayName = displayName;
        }
    }

    public class ContactListItem
    {
        public int OwnerUserId { get; set; }
        public int ContactUserId { get; set; }
    }

    public static class FakeDAL
    {
        private static List<User> _users;
        private static List<ContactListItem> _contactList;
        public static int userCounter;

        static FakeDAL()
        {
            _users = new List<User>();
            //_users = new List<User>
            //{
            //    new User(1,"alikazmi", "pass1", "Ali Kazmi"),
            //    new User(2,"mnagaria", "pass2", "Mohsin"),
            //    new User(3,"mzia", "pass3", "Mehmood")
            //};


            _contactList = new List<ContactListItem>
            {
                new ContactListItem{ OwnerUserId = 1, ContactUserId = 2},
                new ContactListItem{ OwnerUserId = 2, ContactUserId = 1},
                new ContactListItem{ OwnerUserId = 1, ContactUserId = 3},
                new ContactListItem{ OwnerUserId = 3, ContactUserId = 1}
            };

            userCounter = 0;
        }

        public static User GetUser(string username)
        {
            var user = _users.FirstOrDefault(u => u.Username == username);
            if (user == null)
            {
                user = new User(++userCounter, username, string.Empty, username);
                _users.Add(user);
            }
            return user;
            //return _users.FirstOrDefault(u => u.Username.ToLower() == username.ToLower());
        }

        public static User GetUserById(int userId)
        {
            return _users.FirstOrDefault(u => u.UserId == userId);
        }

        public static List<ContactListItem> GetContacts(int userId)
        {
            return _contactList.Where(c => c.OwnerUserId == userId).ToList();
        }

        public static List<User> GetAllUsers()
        {
            return _users.ToList();
        }

        public static List<User> GetAllContacts(int userId)
        {
            return _users.Where(u => u.UserId != userId).ToList();
        }
    }
}