﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using MangoService;
using MangoChat;
using MangoService.SQLStorage;
using System.Configuration;

namespace MangoTest
{
    public class Global : System.Web.HttpApplication
    {

        protected void Application_Start(object sender, EventArgs e)
        {

            if (bool.Parse(ConfigurationManager.AppSettings["UseSqlProvider"]))
            {
                Service.Instance.Storage = new SQLServerStorageProvider();
            }
            
            ChatService.Start();
            //ChatService.OnContactsRequired += new Action<OnContactsRequiredEventArgs>(ChatService_OnContactsRequired);
            ChatService.OnUserInfoRequired += new Action<OnUserInfoRequiredEventArgs>(ChatService_OnUserInfoRequired);
        }

        void ChatService_OnUserInfoRequired(OnUserInfoRequiredEventArgs obj)
        {
            var dbUser = DAL.FakeDAL.GetUserById(Convert.ToInt32(obj.UserId));
            var user = new User { UserId = dbUser.UserId.ToString(), Username = dbUser.DisplayName};
            obj.User = user;
        }

        /*void ChatService_OnContactsRequired(OnContactsRequiredEventArgs obj)
        {
            //if (obj.User.UserId == "1")
            //{
            //    obj.Contacts.Add(new Contact { UserId = "2", Username = "Mohsin" });
            //    obj.Contacts.Add(new Contact { UserId = "3", Username = "Mehmood" });
            //}
            //else
            //    obj.Contacts.Add(new Contact { UserId = "1", Username = "Ali Kazmi" });

            var users = DAL.FakeDAL.GetAllContacts(Convert.ToInt32(obj.User.UserId)).OrderBy(u => u.DisplayName).ToList();
            foreach (DAL.User dbUser in users)
            {
                var user = new Contact { UserId = dbUser.UserId.ToString(), Username = dbUser.DisplayName, ContactGroup = dbUser.DisplayName.Substring(0,1).ToUpper()};
                obj.Contacts.Add(user);
            }
            
        }*/

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
    }
}